#include <stdio.h>
#include <dlfcn.h>
#include <string.h>
#include <limits.h>
#include <fcntl.h>

#ifndef RTLD_NEXT
#define RTLD_NEXT	  ((void *) -1l)
#endif

#define PATH_MTAB "/etc/mtab"

int open(const char *path, int oflag, ...) {
    static int             (*func) (const char *, int, ...);
    int                    fd, fdfstab;
    char tmpfile[] = "/tmp/mtab.XXXXXX";
    char cmd[80];

    if (!func)
	func = (int (*) (const char *, int, ...)) dlsym (RTLD_NEXT, "open");

    if (strcmp(path, PATH_MTAB))
	return func(path, oflag, 0600);

    if ((fd = mkstemp(tmpfile)) < 0) {
	perror("libmtab.so: mkstemp:");
    }
    sprintf(cmd, "sed 's/ufs/ext2/' < /etc/fstab > %s", tmpfile);
    system(cmd);
    unlink(tmpfile);
    return (fd);
}
